=== debian/changelog ===
fckit (0.14.2-1) unstable; urgency=medium

  [ Alastair McKinstry ]
  * New upstream release
  * Fix d/copyright format for licenserecon
  * Use pre-computed DEB_HOST_MULTIARCH
  * Add d/salsa-ci.yml
  * Move dh-sequence-fortran-mod to dh-sequence-fortran
  * Drop dh_dwz as automatically handled by dh_fortran
  * Use dh_fortran_lib to handle libraries
  * Build with lfortran, flang-21 as optional compilers for testing
  * Now need get_ld_flags for cmake/flang linking
  * Standards-Version: 4.7.3
  * Drop priority: optional
  * Make Science team the maintainer, myself the uploader
  * Update the VCS as its now in debian-science-team
  * Don't set RPATHS
  * Build against gfortran-15,flang-21

  [ Andreas Tille ]
  * d/watch: version=5

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 13:25:09 +0000
