=== debian/control ===
Source: fckit
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran,
  gfortran-15,
  flang-21,
  lfortran,
  ecbuild (>= 3.3.0-2),
  python3-all,
  libeckit-dev (>= 1.29.1-1~),
  libssl-dev,
  libcurl4-gnutls-dev
Standards-Version: 4.7.3
Homepage: https://github.com/ecmwf/fckit
Vcs-Browser: https://salsa.debian.org/science-team/fckit
Vcs-Git: https://salsa.debian.org/science-team/fckit.git

Package: libfckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfckit0d (= ${binary:Version}), ${shlib:Depends}, ${misc:Depends},
 ${fortran:Depends}, libeckit-dev
Description: Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit-utils
Architecture: all
Depends: ${misc:Depends}, libfckit-dev, python3
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
