=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

export FC_DEFAULT:= gfortran-15
export FC_OPTIONAL:=flang-21

export DH_VERBOSE=1

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
FMODDIR:=$(shell dh_fortran get_fmoddir)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

BUILD_FLAGS = 

NO_TEST_ARCH:= mips64el 
DO_TEST:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_TEST_ARCH)), false, true)

%:
	dh $@ --buildsystem=ecbuild --with fortran

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*
		

override_dh_auto_configure:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		FCFLAGS=`dh_fortran get_fc_flags --fc $$f` ; \
		LDFLAGS=`dh_fortran get_ld_flags --fc $$f`  \
		dh_auto_configure --builddirectory=debian/build-$$f  -- \
			${BUILD_FLAGS} \
			-DCMAKE_Fortran_COMPILER=$$f \
			-DCMAKE_Fortran_FLAGS="$${FCFLAGS}" \
			-DCMAKE_SKIP_INSTALL_RPATH=On ; \
		done

override_dh_auto_test:
	$(DO_TEST) && (  for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_test --builddirectory=debian/build-$$f ; \
		done )   || echo "Ignoring test failures"

override_dh_auto_build:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_build --builddirectory=debian/build-$$f ; done

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-$(FC_DEFAULT)
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%$${fckit_BASE_DIR}/libexec%/usr/bin%g'                           $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	              $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-eval.sh%fckit-eval%'                          	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fctest-generate-runner.py%fctest-generate-runner%'  	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  		 	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libfckit%${LIBDIR}/libfckit%g'            $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${FMODDIR}%g' 			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%python3\.[0-9]*%python3%g'  				      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	# TODO: This will need work when flang is supported
	sed -i -e 's%libfckit.so.0d%libfckit-${FC_DEFAULT}.so.0d%g'			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets-release.cmake
	# rename those with script extensions
	mv $(TMPDIR)/usr/libexec/fckit-eval.sh $(TMPDIR)/usr/libexec/fckit-eval
	mv $(TMPDIR)/usr/libexec/fckit-fypp.py $(TMPDIR)/usr/libexec/fckit-fypp
	mv $(TMPDIR)/usr/libexec/fctest-generate-runner.py $(TMPDIR)/usr/libexec/fctest-generate-runner
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/fckit/*
